#include "pam_stuff.h"
#include <stdio.h>
#include <pwd.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
                     
#include <string.h>
#include <errno.h>

#define USAGE "%s: username <filename1 .. filenameN> \n"
//#define SERVICEGIVE MAKEFILE!

int main(int argc, char **argv) {
	// 1. Input validation
	
	// Need atleast 1 file!
	if (argc<3) {
		fprintf(stderr, USAGE, argv[0]);
		exit(1);
	}
	
	// The username must be valid
	struct passwd *userinfo = getpwnam(argv[1]);
	if (userinfo==NULL) {
		fprintf(stderr, "%s: No such user! (or an eror occured)\n", argv[0]);
		exit(1);
	}
	
	// Which way do we copy?
	#ifdef SERVICEGIVE
	#define SERVICE "give"
	unsigned int fromuid = getuid();
	unsigned int touid = userinfo->pw_uid;
	#else
	#define SERVICE "take"
	unsigned int fromuid = userinfo->pw_uid;
	unsigned int touid = getuid();
	#endif

	// NOT ROOT! NEVER ROOT! :>
	if (fromuid==0 || touid==0) {
		fprintf(stderr, "%s: Security trough obscurity\n", argv[0]);
		exit(1);
	}
	
	//free(userinfo);
	
	// 2. Authentication
	if (pam_stuff_authenticate(SERVICE, argv[1]) != 1) {
		fprintf(stderr, "%s: Authentication failed.\n", argv[0]);
		exit(2);
	}

	// 3. Action!
	
	int i = 2; // first file
	for (;i<argc;i++) {
		int fd;
		struct stat fileinfo;
		
		fd = open(argv[i], O_RDWR);
		if (fd==-1) {
			fprintf(stderr, "%s: %s\n", argv[i], strerror(errno));
			continue;
		}
		
		// stating
		if (fstat(fd, &fileinfo)==-1) {
			fprintf(stderr, "%s: %s\n", argv[i], strerror(errno));
			goto cleanup;
		}
		
		// check if we really are going to take/give ownership of a file
		if (fileinfo.st_uid!=fromuid) {
			fprintf(stderr, "%s: Ownership mismatch.\n", argv[i]);
			goto cleanup;
		}
		
		// give/take file
		if (fchown(fd, touid, fileinfo.st_gid)==-1) {
			fprintf(stderr, "%s: %s\n", argv[i], strerror(errno));
			goto cleanup;
		}
	
		printf("%s\n", argv[i]);

		cleanup:
		close(fd);
	}
}

// EOF
