/*
 * Mostly taken from an application example in the
 * in the PAM documentation which were written by
 * Shane Watts [modifications by AGM]
 */

#include <security/pam_appl.h>
#include <security/pam_misc.h>

static struct pam_conv conv = {
    misc_conv,
    NULL
};

int pam_stuff_authenticate(char *servicename, char *username) {
	pam_handle_t *pamh=NULL;
	int retval, authok;
	authok = 0;

	retval = pam_start(servicename, username, &conv, &pamh);

	if (retval == PAM_SUCCESS)
		retval = pam_authenticate(pamh, 0);    /* is user really user? */

	if (retval == PAM_SUCCESS)
		retval = pam_acct_mgmt(pamh, 0);       /* permitted access? */
	
	if (retval==PAM_SUCCESS) {
		authok = 1;
	}

	/* Cleanup */
	if (pam_end(pamh, retval) != PAM_SUCCESS) {     /* close Linux-PAM */
		fprintf(stderr, "%s: failed to release authenticator\n", servicename);
		exit(1);
	}

	//return ( retval == PAM_SUCCESS ? 0:1 );       /* indicate success */
	return authok;
}

